function [M, rt, recall, drift, t] = Dotrial(M, set, position, CSI)

global C P; 

%During the CSI: loading relevant task set into bridge (M.w)
t = 0;
if (set > 0)
    loadmemory = 1;
    if C.preparation == 0, vW = M.listcue(set,:)*M.W; end %instantly retrieves vectorized weight matrix from list cue,...
    if C.preparation == 1
        startpoints = randn(1, C.un*C.cun)*P.noise;  %start values for accumulators in set layer
        retrievaltime = (P.boundary-startpoints)./P.setdrift; 
        Retrievaltime = min(retrievaltime); %stop retrieving after the first unit in set layer reached boundary
        vW = Retrievaltime*P.setdrift*(M.listcue(set,:)*M.W); 
        t = Retrievaltime; 
    end
    while loadmemory == 1
        w = reshape(M.w,1,numel(M.w));  %current state of M.w, vectorized
        delta = sum(abs(vW-w));         %measures difference between actual and desired state of M.w
        if delta < P.crit
            loadmemory = 0;
        end
        if loadmemory == 1 
            M.w = M.w + P.rate * reshape(vW-w, C.cun, C.un);
            t = t + C.timestep;
        end
        if t > 10, loadmemory = 0; end
    end
end

% Item selection: using bindings in M.w and associations in M.ltmw to retrieve the item in given position

M.cueact = M.cueact * P.cuepriming + M.cue(position,:);                 %here, cue priming happens by dampening cueact to less than zero
M.retrieved = M.candidates + M.cueact * (M.w + M.assw);
drift = M.retrieved*M.stim';     %this translates distributed representations into localist ones (insofar as needed)

if C.rt == 1
    M.accumulators = min(P.boundary, M.accumulators + randn(size(M.accumulators))*P.noise);   %noise on starting point
    RT = (P.boundary-M.accumulators)./max(0.001, drift); %uses M.accumulators as variable starting point. RT = time to reach boundary for each accumulator
    recall = find(RT == min(RT));  %response selected is the one that has the shortest RT
    rt = min(P.deadline, min(RT)) + max(0, t-CSI);  %selects smallest decision time (RT) and adds (re-)configuration time insofar it exceeds CSI
    M.accumulators = M.accumulators + drift.*min(RT);  %final state of accumulators
    losers = M.accumulators < max(M.accumulators);
    M.accumulators(losers) = 0; %sets all values that haven't reached the boundary back to zero to disambiguate the content of the focus of attention
end
if C.rt == 2
    M.accumulators = zeros(1,C.un);
    rt = 0;
    while max(M.accumulators) < P.boundary && rt < P.deadline
        M.accumulators = max(0,M.accumulators + P.accrate*(drift + M.accumulators*M.winhib) + randn(1,C.un).*0.3*P.noise); %noise scaled down relative to LBA
        rt = rt + C.timestep;
    end
    rt = rt + max(0, t-CSI);
    recall = find(M.accumulators == max(M.accumulators));
    recall = recall(1);
end

%Strengthening bindings and associations
expectation = M.cueact * M.w;
M.w = M.w + P.focusing * (M.cueact' * (M.accumulators - expectation));   %strengthen bindings
expectation2 = M.cueact * M.assw;
M.assw = M.assw + (P.focusing*P.asslearnrate) *(M.cueact' * (M.accumulators - expectation2));  %strengthen associations in LTM

%response suppression, resetting of accumulators
M.accumulators = zeros(1, C.un);
M.candidates = M.candidates + (P.itemact-M.candidates).*P.inhibrestor;
M.candidates(recall) = M.candidates(recall).*(1-P.rsupp);


