function ListSwitch125

global E C P O M;

O.result = zeros(E.nsubjects*3*length(E.CSI)*E.ntrials*(E.nsteps-1), 10);
O.drifts = zeros(E.nsubjects*3*length(E.CSI)*E.ntrials*(E.nsteps-1), 16);
pointer = 1;

M.cue = zeros(E.setsize);
for c = 1:E.setsize
    M.cue(c,:) = exp(-P.cuedist*(abs(c - (1:E.setsize))));
end
C.cunlist = 2;                   %two lists
C.cun = size(M.cue,2);
C.un = 9;                        %nine digits
P.crit = P.crit * C.un * C.cun;  %multiply with number of weights in M.w
for c = 1:2
    M.listcue(c,:) = exp(-P.ltmcuedist*abs(c - (1:2)));
end
M.stim = diag(ones(1,C.un));  %localist representations of digits

M.winhib = -(ones(C.un)-diag(ones(1,C.un))).*(P.accinhib/C.un) - diag(ones(1,C.un)).*P.accnetleak;
% for Usher/McClelland: mutual inhibition is calibrated relative to number of accumulators by dividing P.accinhib by length(drift)


for id = 1:E.nsubjects
    for cond = 1:3
        for csi = 1:length(E.CSI)
            
            list = randperm(C.un);
            List = [list(1:3); list(4:6)];
            reploc = randperm(3);
            if cond == 1, List(1,reploc(1)) = List(2,reploc(1)); reppos = [1, reploc(1); 2, reploc(1)]; end   %repetition in other list, same list position
            if cond == 2, List(1,reploc(1)) = List(2,reploc(2)); reppos = [1, reploc(1); 2, reploc(2)]; end   %repetition in other list, different list position
            if cond == 3, List(1,reploc(1)) = List(1,reploc(2)); reppos = [1, reploc(1); 1, reploc(2)]; end   %repetition in same list, different position
            
            M = Pretraining(M, List);
            
            for trial = 1:E.ntrials
                
                result = zeros(19,10);
                drifts = zeros(19,16);
                M.candidates = P.itemact * ones(1, C.un);
                M.accumulators = zeros(1,C.un);
                Set = zeros(1,E.nsteps); Pos = zeros(1,E.nsteps);
                
                for r = 1:E.nsteps   %number of successive retrievals

                    sel1 = randperm(2);
                    sel2 = randperm(E.setsize);
                    Set(r) = sel1(1);
                    Pos(r) = sel2(1);         %select position to be recalled rom
                    list = List(Set(r),:);    %select the set (list) to be recalled from
                    
                    [M, rt, recall, drift] = Dotrial(M, Set(r), Pos(r), E.CSI(csi));
                    
                    % Collect data
                    correct = recall == list(Pos(r));
                    if r > 1,
                        O.response = [recall, correct, Pos(r), list];
                        digrep = List(Set(r), Pos(r)) == List(Set(r-1), Pos(r-1));
                        congruency = 0;
                        for n = 1:2
                            if Set(r) == reppos(n,1) && Pos(r) == reppos(n,2); congruency = 1; end  %if current set and position match one of the set-pos pairs marking the 2 instances of the repeated item, we call this "congruent", even when the pairs appear in different position!
                        end
                        setswitch = Set(r)~=Set(r-1);
                        posswitch = Pos(r)~=Pos(r-1);
                        
                        result(r-1,:) = [cond, E.CSI(csi), setswitch, posswitch, digrep, congruency, correct, rt, drift(list(Pos(r))), M.retrieved(list(Pos(r)))];
                        drifts(r-1,:) = [cond, E.CSI(csi), setswitch, posswitch, digrep, congruency, correct, drift];
                    end
                    
                end
                O.result(pointer:pointer+(E.nsteps-2),:) = result;
                O.drifts(pointer:pointer+(E.nsteps-2),:) = drifts;
                pointer = pointer+(E.nsteps-1);
                
            end  %trial
        end  %CSI
    end  %cond
end  %id

if size(O.result,2) < 5000000
    O.Result = aggregate(O.result(:, 1:6), O.result);
    O.RT = aggregate(O.result(O.result(:,7)==1, 1:6), O.result(O.result(:, 7)==1, :));
    try
        O.Errors = aggregate(O.result(O.result(:,7)==0, 1:6), O.result(O.result(:,7)==0, :));
    catch
    end
else
    save Lswi1results O
    clear all
    load Lswi1results
    
    O.Result = zeros(15,size(O.result,2));
    O.RT = zeros(15, size(O.result,2));
    O.Errors = zeros(15, size(O.result,2));
    S = 0;
    for s = 3:4; %1:floor(size(O.result,1)/5000000)
        S = S+1;
        section = (s-1)*5000000 + 1:(s*5000000);
        O.Result = O.Result + aggregate(O.result(section, 1:6), O.result(section,:));
        O.RT = O.RT + aggregate(O.result(O.result(section,7)==1, 1:6), O.result(O.result(section,7)==1, :));  %RTs of correct responses by conditions
        try
            O.Errors = O.Errors + aggregate(O.result(O.result(section,7)==0, 1:6), O.result(O.result(section,7)==0, :));
        catch
            S = S-1;
        end
    end
    O.Result = O.Result./s;
    O.RT = O.RT./s;
    O.Errors = O.Errors./S;
end

%generate plot analogous to data plot for Listswitch Experiment 2 (CSI manipulation)
placement = [0.1, 0.1, 0.4, 0.35;    %left, bottom, width, height; start with bottom row for condition 1 (rep in same position)
             0.6, 0.1, 0.4, 0.35;
             0.1, 0.6, 0.4, 0.35;
             0.6, 0.6, 0.4, 0.35];
titletext = {'Rep in Same Pos, Short CSI', 'Rep in Same Pos, Long CSI', 'Rep in Different Pos, Short CSI', 'Rep in Different Pos, Long CSI'};
legtext1 =  {'Set Rep con', 'Set Switch con', 'Set Rep incon', 'Set Switch incon'};
legtext2 =  {'Set Repetition', 'Set Switch'};
figure
for cond = 1:2
    for csi = 1:2
        if cond == 1   %Rep in same - differentiate congruent and incongruent
            selcon = (O.result(:,1)==cond) .* (O.result(:,2) == E.CSI(csi)) .* (O.result(:, 4) ~= O.result(:, 5)) .* (O.result(:, 6) == 1) .* (O.result(:, 7) == 1); %selects wanted condition and CSI, posswitch==digchange, congruent trials, correct only.
            Selcon = O.result(selcon==1, :);
            MSelcon = aggregate(Selcon(:, [3, 5]), Selcon);   %aggregates with set switching and digit repetition as break variables
            selincon = (O.result(:,1)==cond) .* (O.result(:,2) == E.CSI(csi)).* (O.result(:, 4) ~= O.result(:, 5)) .* (O.result(:, 6) == 0) .* (O.result(:, 7) == 1);
            Selincon = O.result(selincon==1, :);
            MSelincon = aggregate(Selincon(:, [3, 5]), Selincon);   %aggregates with set switching and digit repetition as break variables
            DV = [MSelcon([2,1], 8), MSelcon([4,3], 8), MSelincon([2,1], 8), [nan; MSelincon(3,8)]]; %MSel(1:2, 8) = set repetition, but the first entry = digit change, so to have digit repetition first, reorder. First column is plotted as first line
            PreFigure(2, placement((cond-1)*2 + csi, :));
            plot(1:2, DV);
            PostFigure([0.5, 2.5, 0, 3], 'Digit Rep     Digit Change', 'RT', cell2mat(titletext((cond-1)*2 + csi)), legtext1);
        end
        if cond == 2   %Rep in different - don't care about "congruency"
            posdig1 =(O.result(:, 3) == 0) .* (O.result(:, 4) == 0) .* (O.result(:, 5) == 1);    %selects task rep, position rep and digit rep
            posdig2 =(O.result(:, 3) == 0) .* (O.result(:, 4) == 1) .* (O.result(:, 5) == 0);    %selects task rep, position swi and digit change
            posdig3 =(O.result(:, 3) == 1) .* (O.result(:, 4) == 1) .* (O.result(:, 5) == 1);    %selects task swi, position swi and digit rep
            posdig4 =(O.result(:, 3) == 1) .* (O.result(:, 4) == 1) .* (O.result(:, 5) == 0);    %selects task swi, position swi and digit change
            posdig = sum([posdig1, posdig2, posdig3, posdig4], 2) > 0; %if any of the four posdig conditions is fulfilled, select
            sel = (O.result(:,1)==cond) .* (O.result(:,2) == E.CSI(csi)) .* posdig .* (O.result(:, 7) == 1); %selects wanted condition and CSI, not caring about "congruency", correct only.
            Sel = O.result(sel==1, :);
            MSel = aggregate(Sel(:, [3, 5]), Sel);   %aggregates with set switching and digit repetition as break variables
            PreFigure(0, placement((cond-1)*2 + csi, :));
            plot([MSel([2,1], 8), MSel([4,3], 8)]);    %MSel(1:2, 8) = set repetition, but the first entry = digit change, so to have digit repetition first, reorder. First column is plotted as first line
            PostFigure([0.5, 2.5, 0, 3], 'Digit Rep     Digit Change', 'RT', cell2mat(titletext((cond-1)*2 + csi)), legtext2);
        end
    end
end

%generate plot analogous to data plot for Listswitch Experiment 5 (repetition in other list, different position / rep. in other list, same position / rep. in same list, other position)
allrep_con =   (O.result(:,1) == 3) .* (O.result(:,2) == 0.1) .* (O.result(:,3) == 0) .* (O.result(:,4) == 0) .* (O.result(:,5) == 1) .* (O.result(:,6) == 1) .*(O.result(:,7) == 1);
allrep_incon = (O.result(:,1) == 3) .* (O.result(:,2) == 0.1) .* (O.result(:,3) == 0) .* (O.result(:,4) == 0) .* (O.result(:,5) == 1) .* (O.result(:,6) == 0) .*(O.result(:,7) == 1);
listrep_posswi_digrep =       (O.result(:,1) == 3) .* (O.result(:,2) == 0.1) .* (O.result(:,3) == 0) .* (O.result(:,4) == 1) .* (O.result(:,5) == 1) .* (O.result(:,6) == 1) .*(O.result(:,7) == 1);
listrep_posswi_digchg_con =   (O.result(:,1) == 3) .* (O.result(:,2) == 0.1) .* (O.result(:,3) == 0) .* (O.result(:,4) == 1) .* (O.result(:,5) == 0) .* (O.result(:,6) == 1) .*(O.result(:,7) == 1);
listrep_posswi_digchg_incon = (O.result(:,1) == 3) .* (O.result(:,2) == 0.1) .* (O.result(:,3) == 0) .* (O.result(:,4) == 1) .* (O.result(:,5) == 0) .* (O.result(:,6) == 0) .*(O.result(:,7) == 1);
listswi_posrep_digrep =       (O.result(:,1) == 1) .* (O.result(:,2) == 0.1) .* (O.result(:,3) == 1) .* (O.result(:,4) == 0) .* (O.result(:,5) == 1) .* (O.result(:,6) == 1) .*(O.result(:,7) == 1);
listswi_posrep_digchg =       (O.result(:,1) == 1) .* (O.result(:,2) == 0.1) .* (O.result(:,3) == 1) .* (O.result(:,4) == 0) .* (O.result(:,5) == 0) .* (O.result(:,6) == 0) .*(O.result(:,7) == 1);
listswi_posswi_digrep =       (O.result(:,1) == 2) .* (O.result(:,2) == 0.1) .* (O.result(:,3) == 1) .* (O.result(:,4) == 1) .* (O.result(:,5) == 1) .*(O.result(:,7) == 1);
listswi_posswi_digchg =       (O.result(:,1) == 2) .* (O.result(:,2) == 0.1) .* (O.result(:,3) == 1) .* (O.result(:,4) == 1) .* (O.result(:,5) == 0) .*(O.result(:,7) == 1);
DV = nan(2,11);  %first row = congruent, 2nd = incongruent, conditions = left to right

DV(1,1) = mean(O.result(allrep_con==1, 8));
DV(2,1) = mean(O.result(allrep_incon==1, 8));

DV(1,4) = mean(O.result(listrep_posswi_digrep==1, 8));
DV(1,5) = mean(O.result(listrep_posswi_digchg_con==1, 8));
DV(2,5) = mean(O.result(listrep_posswi_digchg_incon==1, 8));

DV(1,7) = mean(O.result(listswi_posrep_digrep==1, 8));
DV(2,8) = mean(O.result(listswi_posrep_digchg==1, 8));

DV(2,10) = mean(O.result(listswi_posswi_digrep==1, 8));
DV(2,11) = mean(O.result(listswi_posswi_digchg==1, 8));

X = [1 2 2.5 3 4 4.5 5 6 6.5 7 8];

PreFigure;
plot(X, DV');
PostFigure([0.5, 8.5, 0, 3], 'Lr.Pr.Dr    Lr.Pr.Dch    Lr.Ps.Dr    Lr.Ps.Dch    Ls.Pr.Dr    Ls.Pr.Dch    Ls.Ps.Dr    Ls.Ps.Dch', 'RT', 'Experiment 5', {'Congruent', 'Incongruent'});

% position repetition effect
posrep = (O.result(:,3)==1) .* (O.result(:,4)==0) .* (O.result(:,5)==0) .* (O.result(:,6)==0) .* (O.result(:,7)==1);   %list switch, position repetition, digit change, incongruent, correct
posswi = (O.result(:,3)==1) .* (O.result(:,4)==1) .* (O.result(:,5)==0) .* (O.result(:,6)==0) .* (O.result(:,7)==1);   %list switch, position switch, digit change, incongruent, correct
Prepeffect(1) = mean(O.result(posrep==1,8));
Prepeffect(2) = mean(O.result(posswi==1,8))

% item-in-position repetition effect (classic object-repetition effect)
itemrep = (O.result(:,3)==0) .* (O.result(:,4)==0) .* (O.result(:,5)==1) .* (O.result(:,6)==0) .* (O.result(:,7)==1);   %list repetition, position repetition, digit repetition, incongruent, correct
itemswi = (O.result(:,3)==0) .* (O.result(:,4)==1) .* (O.result(:,5)==0) .* (O.result(:,6)==0) .* (O.result(:,7)==1);   %list repetition, position switch, digit change, incongruent, correct
IPrepeffect(1) = mean(O.result(itemrep==1,8));
IPrepeffect(2) = mean(O.result(itemswi==1,8))

% "neutral" vs. "incongruent" in lists with repetitions in different
% positions (condition 2), as requested by a reviewer:

NeutralListrepPosswiDigchange = (O.result(:,1)==2) .* (O.result(:,3)==0) .* (O.result(:,4)==1) .* (O.result(:,5)==0) .*(O.result(:,6)==0) .* (O.result(:, 7) == 1); %selects listreps, pos-swi, digit-change, not-"congruent", correct.
NeutralListswiPosrepDigchange = (O.result(:,1)==2) .* (O.result(:,3)==1) .* (O.result(:,4)==0) .* (O.result(:,5)==0) .*(O.result(:,6)==0) .* (O.result(:, 7) == 1); %selects listswi, pos-rep, digit-change, not-"congruent", correct.
NeutralListswiPosswiDigchange = (O.result(:,1)==2) .* (O.result(:,3)==1) .* (O.result(:,4)==1) .* (O.result(:,5)==0) .*(O.result(:,6)==0) .* (O.result(:, 7) == 1); %selects listswi, pos-swi, digit-change, not-"congruent", correct.

InconListrepPosswiDigchange = (O.result(:,1)==2) .* (O.result(:,3)==0) .* (O.result(:,4)==1) .* (O.result(:,5)==0) .*(O.result(:,6)==1) .* (O.result(:, 7) == 1); %selects listreps, pos-swi, digit-change, "congruent" (i.e., what the reviewer called incongruent), correct.
InconListswiPosrepDigchange = (O.result(:,1)==2) .* (O.result(:,3)==1) .* (O.result(:,4)==0) .* (O.result(:,5)==0) .*(O.result(:,6)==1) .* (O.result(:, 7) == 1); %selects listswi, pos-rep, digit-change, "congruent", correct.
InconListswiPosswiDigchange = (O.result(:,1)==2) .* (O.result(:,3)==1) .* (O.result(:,4)==1) .* (O.result(:,5)==0) .*(O.result(:,6)==1) .* (O.result(:, 7) == 1); %selects listswi, pos-swi, digit-change, "congruent", correct.

DV = zeros(3,2);
DV(:,1) = [mean(O.result(NeutralListrepPosswiDigchange==1, 8));
    mean(O.result(NeutralListswiPosrepDigchange==1, 8));
    mean(O.result(NeutralListswiPosswiDigchange==1, 8))];
DV(:,2) = [mean(O.result(InconListrepPosswiDigchange==1, 8));
    mean(O.result(InconListswiPosrepDigchange==1, 8));
    mean(O.result(InconListswiPosswiDigchange==1, 8))];
disp('Neutral vs Incongruent in Lists with digit repetitions in different positions');
disp(DV);


disp('     cond     CSI     setswitch  posswitch  digrep  congruency  correct     rt      drift');
disp(O.Result);


%Diagnostics
cond = 2;
figure;
for csi = 1:2
    posdig1 =(O.result(:, 3) == 0) .* (O.result(:, 4) == 0) .* (O.result(:, 5) == 1);    %selects task rep, position rep and digit rep
    posdig2 =(O.result(:, 3) == 0) .* (O.result(:, 4) == 1) .* (O.result(:, 5) == 0);    %selects task rep, position swi and digit change
    posdig3 =(O.result(:, 3) == 1) .* (O.result(:, 4) == 1) .* (O.result(:, 5) == 1);    %selects task swi, position swi and digit rep
    posdig4 =(O.result(:, 3) == 1) .* (O.result(:, 4) == 1) .* (O.result(:, 5) == 0);    %selects task swi, position swi and digit change
    posdig = sum([posdig1, posdig2, posdig3, posdig4], 2) > 0; %if any of the four posdig conditions is fulfilled, select
    sel = (O.result(:,1)==cond) .* (O.result(:,2) == E.CSI(csi)) .* posdig .* (O.result(:, 7) == 1); %selects wanted condition and CSI, not caring about "congruency", correct only.
    Sel = O.result(sel==1, :);
    MSel = aggregate(Sel(:, [3, 5]), Sel);   %aggregates with set switching and digit repetition as break variables
    PreFigure(0, placement(2 + csi, :));
    plot([MSel([2,1], 8), MSel([4,3], 9)]);    %MSel(1:2, 9) = set repetition, but the first entry = digit change, so to have digit repetition first, reorder. First column is plotted as first line
    PostFigure([0.5, 2.5, 0, 3], 'Digit Rep     Digit Change', 'Drift', cell2mat(titletext((cond-1)*2 + csi)), legtext2);
    PreFigure(0, placement(csi, :));
    plot([MSel([2,1], 8), MSel([4,3], 10)]);    %MSel(1:2, 9) = set repetition, but the first entry = digit change, so to have digit repetition first, reorder. First column is plotted as first line
    PostFigure([0.5, 2.5, 0, 3], 'Digit Rep     Digit Change', 'Binding', cell2mat(titletext((cond-1)*2 + csi)), legtext2);
end









