function M = Pretraining(M, List)

global C P E;

%pre-training of lists
M.w = zeros(C.cun, C.un);
M.assw = zeros(C.cun, C.un);
M.W = zeros(C.cunlist, C.un*C.cun);
M.cueact = zeros(size(M.cue(1,:)));
M.accumulators = zeros(1,C.un);

for trial = 1:E.npretraining
    for set = 1:size(List,1)
        list = List(set,:); %select the set to be encoded
        for position = 1:length(list)
            M.cueact = M.cueact * P.cuepriming + M.cue(position,:);
            M.accumulators = M.stim(list(position),:);   %feedback about the correct item is placed in the item layer
            expectation = M.cueact * M.w;
            M.w = M.w + M.cueact' * (M.accumulators - expectation);
            expectation2 = M.cueact * M.assw;
            M.assw = M.assw + P.asslearnrate * M.cueact' * (M.accumulators - expectation2);
        end
        vdw = reshape(M.w,1,numel(M.w));
        Expectation = M.listcue(set,:) * M.W;
        M.W = M.W + P.learnrate*(M.listcue(set,:)' * (vdw-Expectation));
        M.w = zeros(C.cun, C.un); %reset after encoding each list
    end
end

